Index: /trunk/SophyaExt/XephemAstroLib/formats.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/formats.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/formats.c	(revision 2551)
@@ -5,5 +5,4 @@
 #include <string.h>
 
-#include "P_.h"
 #include "astro.h"
 #include "preferences.h"
@@ -17,12 +16,10 @@
  *	600:	<w>:mm.m
  *	60:	<w>:mm
- */
-void
-fs_sexa (out, a, w, fracbase)
-char *out;
-double a;
-int w;
-int fracbase;
-{
+ * return number of characters written to out, not counting final '\0'.
+ */
+int
+fs_sexa (char *out, double a, int w, int fracbase)
+{
+	char *out0 = out;
 	unsigned long n;
 	int d;
@@ -44,8 +41,7 @@
 	/* form the whole part; "negative 0" is a special case */
 	if (isneg && d == 0)
-	    (void) sprintf (out, "%*s-0", w-2, "");
+	    out += sprintf (out, "%*s-0", w-2, "");
 	else
-	    (void) sprintf (out, "%*d", w, isneg ? -d : d);
-	out += w;
+	    out += sprintf (out, "%*d", w, isneg ? -d : d);
 
 	/* do the rest */
@@ -53,39 +49,41 @@
 	case 60:	/* dd:mm */
 	    m = f/(fracbase/60);
-	    (void) sprintf (out, ":%02d", m);
+	    out += sprintf (out, ":%02d", m);
 	    break;
 	case 600:	/* dd:mm.m */
-	    (void) sprintf (out, ":%02d.%1d", f/10, f%10);
+	    out += sprintf (out, ":%02d.%1d", f/10, f%10);
 	    break;
 	case 3600:	/* dd:mm:ss */
 	    m = f/(fracbase/60);
 	    s = f%(fracbase/60);
-	    (void) sprintf (out, ":%02d:%02d", m, s);
+	    out += sprintf (out, ":%02d:%02d", m, s);
 	    break;
 	case 36000:	/* dd:mm:ss.s*/
 	    m = f/(fracbase/60);
 	    s = f%(fracbase/60);
-	    (void) sprintf (out, ":%02d:%02d.%1d", m, s/10, s%10);
+	    out += sprintf (out, ":%02d:%02d.%1d", m, s/10, s%10);
 	    break;
 	case 360000:	/* dd:mm:ss.ss */
 	    m = f/(fracbase/60);
 	    s = f%(fracbase/60);
-	    (void) sprintf (out, ":%02d:%02d.%02d", m, s/100, s%100);
+	    out += sprintf (out, ":%02d:%02d.%02d", m, s/100, s%100);
 	    break;
 	default:
 	    printf ("fs_sexa: unknown fracbase: %d\n", fracbase);
-	    exit(1);
+	    abort();
 	}
+
+	return (out - out0);
 }
 
 /* put the given modified Julian date, jd, in out[] according to preference
  * format.
- */
-void
-fs_date (out, jd)
-char out[];
-double jd;
+ * return number of characters written to out, not counting final '\0'.
+ */
+int
+fs_date (char out[], double jd)
 {
 	int p = pref_get (PREF_DATE_FORMAT);
+	char *out0 = out;
 	int m, y;
 	double d;
@@ -100,81 +98,50 @@
 	switch (p) {
 	case PREF_YMD:
-	    (void) sprintf (out, "%4d/%02d/%02.6g", y, m, d);
+	    out += sprintf (out, "%4d/%02d/%02.6g", y, m, d);
 	    break;
 	case PREF_DMY:
-	    (void) sprintf (out, "%2.6g/%02d/%-4d", d, m, y);
+	    out += sprintf (out, "%2.6g/%02d/%-4d", d, m, y);
 	    break;
 	case PREF_MDY:
-	    (void) sprintf (out, "%2d/%02.6g/%-4d", m, d, y);
+	    out += sprintf (out, "%2d/%02.6g/%-4d", m, d, y);
 	    break;
 	default:
 	    printf ("fs_date: bad date pref: %d\n", p);
-	    exit (1);
+	    abort();
 	}
-}
-
-/* scan a sexagesimal string and update a double. the string is of the form
- *   H:M:S. a negative value may be indicated by a '-' char before any
- *   component. All components may be integral or real. In addition to ':' the
- *    separator may also be '/' or ';' or ',' or '-'.
- * any components not specified in bp[] are copied from old's.
- *   eg:  ::10	only changes S
- *        10    only changes H
- *        10:0  changes H and M
- */
-void
-f_scansex (o, bp, np)
-double o;	/* old value */
-char bp[];	/* input string */
-double *np;	/* new value */
-{
-	double oh, om, os;
-	double nh, nm, ns;
-	int nneg;
-	double tmp;
-	char c;
-
-	/* fast macro to scan each segment of bp */
-#define	SCANSEX(new,old)						\
-	if (*bp == '-') {nneg = 1; bp++;}				\
-	if (sscanf (bp, "%lf", &new) != 1) new = old;			\
-	while ((c=(*bp)) != '\0') {					\
-	    bp++;							\
-	    if (c==':' || c=='/' || c==';' || c==',' || c=='-')		\
-		break;							\
-	}
-
-	/* get h:m:s components of o in case bp[] defers.
-	 * and constrain to positive for now.
-	 */
-	if (o < 0.0)
-	    o = -o;
-        oh = floor(o);
-	tmp = (o - oh)*60.0;
-	om = floor(tmp);
-	os = (tmp - om)*60.0;
-	
-	/* round to small portion of a second to reduce differencing errors. */
-	if (os > 59.99999) {
-	    os = 0.0;
-	    if ((om += 1.0) >= 60.0) {
-		om = 0.0;
-		oh += 1.0;
-	    }
-	}
-
-	/* scan each component of the buffer */
-	while (*bp == ' ') bp++;
-	nneg = 0;
-	SCANSEX (nh, oh)
-	SCANSEX (nm, om)
-	SCANSEX (ns, os)
-
-	/* back to hours */
-	tmp = ns/3600.0 + nm/60.0 + nh;
-	if (nneg)
-	    tmp = -tmp;
-
-	*np = tmp;
+
+	return (out - out0);
+}
+
+
+/* convert sexagesimal string str AxBxC to double.
+ *   x can be anything non-numeric. Any missing A, B or C will be assumed 0.
+ *   optional - and + can be anywhere.
+ * return 0 if ok, -1 if can't find a thing.
+ */
+int
+f_scansexa (
+const char *str0,	/* input string */
+double *dp)		/* cracked value, if return 0 */
+{
+	double a = 0, b = 0, c = 0;
+	char str[128];
+	char *neg;
+	int r;
+
+	/* copy str0 so we can play with it */
+	strncpy (str, str0, sizeof(str)-1);
+	str[sizeof(str)-1] = '\0';
+
+	neg = strchr(str, '-');
+	if (neg)
+	    *neg = ' ';
+	r = sscanf (str, "%lf%*[^0-9]%lf%*[^0-9]%lf", &a, &b, &c);
+	if (r < 1)
+	    return (-1);
+	*dp = a + b/60 + c/3600;
+	if (neg)
+	    *dp *= -1;
+	return (0);
 }
 
@@ -182,126 +149,56 @@
  *   PREF_DATE_FORMAT preference into its components. allow the day to be a
  *   floating point number,
- * a lone component is always a year if it contains a decimal point or pref
- *   is MDY or DMY and it is not a reasonable month or day value, respectively.
- * leave any unspecified component unchanged.
- * actually, the slashes may be anything but digits or a decimal point.
+ * actually the slashes may be anything but digits.
+ * a lone component with a decimal point is considered a year.
  */
 void
-f_sscandate (bp, pref, m, d, y)
-char *bp;
-int pref;       /* one of PREF_X for PREF_DATE_FORMAT */
-int *m, *y;
-double *d;
-{
-        double comp[3]; /* the three components */
-        int set[3];     /* set[i] is 1 if component i is present */
-	int in;		/* scan state: 1 while we are in a component */
-	int ncomp;	/* incremented as each component is discovered */
-	int ndp;	/* number of decimal points in last component */
-        char *bp0 = NULL, c;
-
-	set[0] = set[1] = set[2] = 0;
-	ncomp = 0;
-	in = 0;
-	ndp = 0;
-
-	/* scan the input string.
-	 * '\0' counts as a component terminator too.
-	 */
-	do {
-	    /* here, *bp is the next character to be investigated */
-	    c = *bp;
-	    if (c == '.' || isdigit(c) || (c == '-' && !in)) {
-		/* found what passes for a floating point number */
-		if (in == 0) {
-		    /* save the beginning of it in bp0 and init ndp */
-		    bp0 = bp;
-		    in = 1;
-		    ndp = 0;
-		}
-		if (c == '.')
-		    ndp++;
-	    } else if (c != ' ') {
-		/* not in a number now ... */
-		if (in) {
-		    /* ... but we *were* in a number, so it counts */
-		    if (ncomp >= 3)
-			return;	/* too many components.. just bail */
-		    comp[ncomp] = atod (bp0);
-		    set[ncomp] = 1;
-		    in = 0;
-		}
-
-		/* regardless, a non-blank non-float means another component */
-		ncomp++;
+f_sscandate (
+char *bp,
+int pref,       /* one of PREF_X for PREF_DATE_FORMAT */
+int *m,
+double *d,
+int *y)
+{
+        double c[3]; /* the three components */
+	int n;
+
+	memset (c, 0, sizeof(c));
+	n = sscanf (bp, "%lf%*[^0-9]%lf%*[^0-9]%lf", &c[0], &c[1], &c[2]);
+	if (n == 1 && (strchr(bp, '.')
+			|| (pref == PREF_MDY && (c[0] < 1 || c[0] > 12))
+			|| (pref == PREF_DMY && (c[0] < 1 || c[0] > 31)))) {
+	    double Mjd;
+	    year_mjd (c[0], &Mjd);
+	    mjd_cal (Mjd, m, d, y);
+	} else {
+	    switch (pref) {
+	    case PREF_MDY:
+		if (n > 0 && c[0] != 0)
+		    *m = (int)c[0];
+		if (n > 1 && c[1] != 0)
+		    *d = c[1];
+		if (n > 2 && c[2] != 0)
+		    *y = (int)c[2];
+		break;
+	    case PREF_YMD:
+		if (n > 0 && c[0] != 0)
+		    *y = (int)c[0];
+		if (n > 1 && c[1] != 0)
+		    *m = (int)c[1];
+		if (n > 2 && c[2] != 0)
+		    *d = c[2];
+		break;
+	    case PREF_DMY:
+		if (n > 1 && c[0] != 0)
+		    *d = c[0];
+		if (n > 2 && c[1] != 0)
+		    *m = (int)c[1];
+		if (n > 3 && c[2] != 0)
+		    *y = (int)c[2];
+		break;
 	    }
-	    bp++;
-	} while (c);
-
-	/* it's a decimal year if there is exactly one component and
-	 *   it contains a decimal point
-	 *   or we are in MDY format and it's not in the range 1..12
-	 *   or we are in DMY format and it's not int the rangle 1..31
-	 */
-	if (ncomp == 1 &&
-		(ndp > 0
-		 || (pref == PREF_MDY && !(comp[0] >= 1 && comp[0] <= 12))
-		 || (pref == PREF_DMY && !(comp[0] >= 1 && comp[0] <= 31)))) {
-	    double Mjd;
-	    year_mjd (comp[0], &Mjd);
-	    mjd_cal (Mjd, m, d, y);
-	    return;
 	}
-
-        switch (pref) {
-        case PREF_MDY:
-            if (set[0]) *m = (int)comp[0];
-            if (set[1]) *d = comp[1];
-            if (set[2]) *y = (int)comp[2];
-            break;
-        case PREF_YMD:
-            if (set[0]) *y = (int)comp[0];
-            if (set[1]) *m = (int)comp[1];
-            if (set[2]) *d = comp[2];
-            break;
-        case PREF_DMY:
-            if (set[0]) *d = comp[0];
-            if (set[1]) *m = (int)comp[1];
-            if (set[2]) *y = (int)comp[2];
-            break;
-	}
-}
-
-/* given a string of the form xx:mm[:ss] or xx:mm.dd, convert it to a double at
- * *dp. actually, ':' may also be ';', '/' or ',' too. all components may be 
- * floats.
- * return -1 if trouble, else 0
- */
-int
-scansex (str, dp)
-char *str;
-double *dp;
-{
-	double x, m = 0.0, s = 0.0;
-	int isneg;
-	int nf;
-
-	while (isspace(*str))
-	    str++;
-	if (*str == '-') {
-	    isneg = 1;
-	    str++;
-	} else
-	    isneg = 0;
-
-	nf = sscanf (str, "%lf%*[:;/,]%lf%*[:;/,]%lf", &x, &m, &s);
-	if (nf < 1)
-	    return (-1);
-	*dp = x + m/60.0 + s/3600.0;
-	if (isneg)
-	    *dp = - *dp;
-	return (0);
 }
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: formats.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: formats.c,v $ $Date: 2004-06-15 16:52:38 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/jupmoon.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/jupmoon.c	(revision 2551)
+++ /trunk/SophyaExt/XephemAstroLib/jupmoon.c	(revision 2551)
@@ -0,0 +1,342 @@
+/* jupiter moon info */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+
+#include "astro.h"
+#include "bdl.h"
+
+static int use_bdl (double jd, char *dir, MoonData md[J_NMOONS]);
+static void meeus_jupiter (double d, double *cmlI, double *cmlII,
+    MoonData md[J_NMOONS]);
+static void moonradec (double jupsize, MoonData md[J_NMOONS]);
+static void moonSVis (Obj *eop, Obj *jop, MoonData md[J_NMOONS]);
+static void moonEVis (MoonData md[J_NMOONS]);
+
+/* moon table and a few other goodies and when it was last computed */
+static double mdmjd = -123456;
+static MoonData jmd[J_NMOONS] = {
+    {"Jupiter", NULL},
+    {"Io", "I"},
+    {"Europa", "II"},
+    {"Ganymede", "III"},
+    {"Callisto", "IV"}
+};
+static double sizemjd;	/* size at last mjd */
+static double cmlImjd;	/* central meridian long sys I, at last mjd */
+static double cmlIImjd;	/*    "                      II      " */
+
+/* file containing BDL coefficients */
+static char jbdlfn[] = "jupiter.9910";
+
+/* get jupiter info in md[0], moon info in md[1..J_NMOONS-1].
+ * if !dir always use meeus model.
+ * if !jop caller just wants md[] for names
+ * N.B. we assume eop and jop are updated.
+ */
+void
+jupiter_data (
+double Mjd,		/* mjd */
+char dir[],             /* dir in which to look for helper files */
+Obj *eop,               /* earth == Sun */
+Obj *jop,		/* jupiter */
+double *sizep,		/* jup angular diam, rads */
+double *cmlI, double *cmlII,	/* central meridian longitude, rads */
+MoonData md[J_NMOONS])	/* return info */
+{
+        double JD;
+
+	/* always copy back at least for name */
+	memcpy (md, jmd, sizeof(jmd));
+
+	/* nothing else if repeat call or just want names */
+	if (Mjd == mdmjd || !jop) {
+	    if (jop) {
+		*sizep = sizemjd;
+		*cmlI = cmlImjd;
+		*cmlII = cmlIImjd;
+	    }
+	    return;
+	}
+	JD = Mjd + MJD0;
+
+	/* planet in [0] */
+	md[0].ra = jop->s_ra;
+	md[0].dec = jop->s_dec;
+	md[0].mag = get_mag(jop);
+	md[0].x = 0;
+	md[0].y = 0;
+	md[0].z = 0;
+	md[0].evis = 1;
+	md[0].svis = 1;
+
+	/* size is straight from jop */
+	*sizep = degrad(jop->s_size/3600.0);
+
+	/* mags from JPL ephemeris */
+	md[1].mag = 5.7;
+	md[2].mag = 5.8;
+	md[3].mag = 5.3;
+	md[4].mag = 6.7;
+
+	/* get moon data from BDL if possible, else Meeus' model.
+	 * always use Meeus for cml
+	 */
+	if (dir && use_bdl (JD, dir, md) == 0)
+	    meeus_jupiter (Mjd, cmlI, cmlII, NULL);
+	else
+	    meeus_jupiter (Mjd, cmlI, cmlII, md);
+
+	/* set visibilities */
+	moonSVis (eop, jop, md);
+	moonEVis (md);
+
+	/* fill in moon ra and dec */
+	moonradec (*sizep, md);
+
+	/* save */
+	mdmjd = Mjd;
+	sizemjd = *sizep;
+	cmlImjd = *cmlI;
+	cmlIImjd = *cmlII;
+	memcpy (jmd, md, sizeof(jmd));
+}
+
+/* hunt for BDL file in dir[] and use if possible
+ * return 0 if ok, else -1
+ */
+static int
+use_bdl (
+double JD,		/* julian date */
+char dir[],		/* directory */
+MoonData md[J_NMOONS])	/* fill md[1..NM-1].x/y/z for each moon */
+{
+#define	JUPRAU	.0004769108	/* jupiter radius, AU */
+	double x[J_NMOONS], y[J_NMOONS], z[J_NMOONS];
+	char buf[1024];
+	FILE *fp;
+	int i;
+
+	/* only valid 1999 through 2010 */
+	if (JD < 2451179.50000 || JD >= 2455562.5)
+	    return (-1);
+
+	/* open */
+	(void) sprintf (buf, "%s/%s", dir, jbdlfn);
+	fp = fopen (buf, "r");
+	if (!fp)
+	    return (-1);
+
+	/* use it */
+	if ((i = read_bdl (fp, JD, x, y, z, buf)) < 0) {
+	    fprintf (stderr, "%s: %s\n", jbdlfn, buf);
+	    fclose (fp);
+	    return (-1);
+	}
+	if (i != J_NMOONS-1) {
+	    fprintf (stderr, "%s: BDL says %d moons, code expects %d", jbdlfn, 
+								i, J_NMOONS-1);
+	    fclose (fp);
+	    return (-1);
+	}
+
+	/* copy into md[1..NM-1] with our scale and sign conventions */
+	for (i = 1; i < J_NMOONS; i++) {
+	    md[i].x =  x[i-1]/JUPRAU;	/* we want jup radii +E */
+	    md[i].y = -y[i-1]/JUPRAU;	/* we want jup radii +S */
+	    md[i].z = -z[i-1]/JUPRAU;	/* we want jup radii +front */
+	}
+
+	/* ok */
+	fclose (fp);
+	return (0);
+}
+
+/* compute location of GRS and Galilean moons.
+ * if md == NULL, just to cml.
+ * from "Astronomical Formulae for Calculators", 2nd ed, by Jean Meeus,
+ *   Willmann-Bell, Richmond, Va., U.S.A. (c) 1982, chapters 35 and 36.
+ */
+static void
+meeus_jupiter(
+double d,
+double *cmlI, double *cmlII,	/* central meridian longitude, rads */
+MoonData md[J_NMOONS])	/* fill in md[1..NM-1].x/y/z for each moon.
+			 * N.B. md[0].ra/dec must already be set
+			 */
+{
+#define POLE_RA         degrad(268.05)  /* RA of Jupiter's north pole */
+#define POLE_DEC        degrad(64.50)   /* Dec of Jupiter's north pole */
+#define	dsin(x)	sin(degrad(x))
+#define	dcos(x)	cos(degrad(x))
+	double A, B, Del, J, K, M, N, R, V;
+	double cor_u1, cor_u2, cor_u3, cor_u4;
+	double solc, tmp, G, H, psi, r, r1, r2, r3, r4;
+	double u1, u2, u3, u4;
+	double lam, Ds;
+	double z1, z2, z3,  z4;
+	double De, dsinDe;
+	double theta, phi;
+	double tvc, pvc;
+	double salpha, calpha;
+	int i;
+
+	V = 134.63 + 0.00111587 * d;
+
+	M = (358.47583 + 0.98560003*d);
+	N = (225.32833 + 0.0830853*d) + 0.33 * dsin (V);
+
+	J = 221.647 + 0.9025179*d - 0.33 * dsin(V);
+
+	A = 1.916*dsin(M) + 0.02*dsin(2*M);
+	B = 5.552*dsin(N) + 0.167*dsin(2*N);
+	K = (J+A-B);
+	R = 1.00014 - 0.01672 * dcos(M) - 0.00014 * dcos(2*M);
+	r = 5.20867 - 0.25192 * dcos(N) - 0.00610 * dcos(2*N);
+	Del = sqrt (R*R + r*r - 2*R*r*dcos(K));
+	psi = raddeg (asin (R/Del*dsin(K)));
+
+	*cmlI  = degrad(268.28 + 877.8169088*(d - Del/173) + psi - B);
+	range (cmlI, 2*PI);
+	*cmlII = degrad(290.28 + 870.1869088*(d - Del/173) + psi - B);
+	range (cmlII, 2*PI);
+
+	/* that's it if don't want moon info too */
+	if (!md)
+	    return;
+
+	solc = (d - Del/173.);	/* speed of light correction */
+	tmp = psi - B;
+
+	u1 = 84.5506 + 203.4058630 * solc + tmp;
+	u2 = 41.5015 + 101.2916323 * solc + tmp;
+	u3 = 109.9770 + 50.2345169 * solc + tmp;
+	u4 = 176.3586 + 21.4879802 * solc + tmp;
+
+	G = 187.3 + 50.310674 * solc;
+	H = 311.1 + 21.569229 * solc;
+      
+	cor_u1 =  0.472 * dsin (2*(u1-u2));
+	cor_u2 =  1.073 * dsin (2*(u2-u3));
+	cor_u3 =  0.174 * dsin (G);
+	cor_u4 =  0.845 * dsin (H);
+      
+	r1 = 5.9061 - 0.0244 * dcos (2*(u1-u2));
+	r2 = 9.3972 - 0.0889 * dcos (2*(u2-u3));
+	r3 = 14.9894 - 0.0227 * dcos (G);
+	r4 = 26.3649 - 0.1944 * dcos (H);
+
+	md[1].x = -r1 * dsin (u1+cor_u1);
+	md[2].x = -r2 * dsin (u2+cor_u2);
+	md[3].x = -r3 * dsin (u3+cor_u3);
+	md[4].x = -r4 * dsin (u4+cor_u4);
+
+	lam = 238.05 + 0.083091*d + 0.33*dsin(V) + B;
+	Ds = 3.07*dsin(lam + 44.5);
+	De = Ds - 2.15*dsin(psi)*dcos(lam+24.)
+		- 1.31*(r-Del)/Del*dsin(lam-99.4);
+	dsinDe = dsin(De);
+
+	z1 = r1 * dcos(u1+cor_u1);
+	z2 = r2 * dcos(u2+cor_u2);
+	z3 = r3 * dcos(u3+cor_u3);
+	z4 = r4 * dcos(u4+cor_u4);
+
+	md[1].y = z1*dsinDe;
+	md[2].y = z2*dsinDe;
+	md[3].y = z3*dsinDe;
+	md[4].y = z4*dsinDe;
+
+	/* compute sky transformation angle as triple vector product */
+	tvc = PI/2.0 - md[0].dec;
+	pvc = md[0].ra;
+	theta = PI/2.0 - POLE_DEC;
+	phi = POLE_RA;
+	salpha = -sin(tvc)*sin(theta)*(cos(pvc)*sin(phi) - sin(pvc)*cos(phi));
+	calpha = sqrt (1.0 - salpha*salpha);
+
+	for (i = 0; i < J_NMOONS; i++) {
+	    double tx =  md[i].x*calpha + md[i].y*salpha;
+	    double ty = -md[i].x*salpha + md[i].y*calpha;
+	    md[i].x = tx;
+	    md[i].y = ty;
+	}
+
+	md[1].z = z1;
+	md[2].z = z2;
+	md[3].z = z3;
+	md[4].z = z4;
+}
+
+
+/* given jupiter loc in md[0].ra/dec and size, and location of each moon in 
+ * md[1..NM-1].x/y in jup radii, find ra/dec of each moon in md[1..NM-1].ra/dec.
+ */
+static void
+moonradec (
+double jupsize,		/* jup diameter, rads */
+MoonData md[J_NMOONS])	/* fill in RA and Dec */
+{
+	double juprad = jupsize/2;
+	double jupra = md[0].ra;
+	double jupdec = md[0].dec;
+	int i;
+
+	for (i = 1; i < J_NMOONS; i++) {
+	    double dra  = juprad * md[i].x;
+	    double ddec = juprad * md[i].y;
+	    md[i].ra  = jupra + dra;
+	    md[i].dec = jupdec - ddec;
+	}
+}
+
+/* set svis according to whether moon is in sun light */
+static void
+moonSVis(
+Obj *eop,		/* earth == SUN */
+Obj *jop,		/* jupiter */
+MoonData md[J_NMOONS])
+{
+	double esd = eop->s_edist;
+	double eod = jop->s_edist;
+	double sod = jop->s_sdist;
+	double soa = degrad(jop->s_elong);
+	double esa = asin(esd*sin(soa)/sod);
+	double   h = sod*jop->s_hlat;
+	double nod = h*(1./eod - 1./sod);
+	double sca = cos(esa), ssa = sin(esa);
+	int i;
+
+	for (i = 1; i < J_NMOONS; i++) {
+	    MoonData *mdp = &md[i];
+	    double xp =  sca*mdp->x + ssa*mdp->z;
+	    double yp =  mdp->y;
+	    double zp = -ssa*mdp->x + sca*mdp->z;
+	    double ca = cos(nod), sa = sin(nod);
+	    double xpp = xp;
+	    double ypp = ca*yp - sa*zp;
+	    double zpp = sa*yp + ca*zp;
+	    int outside = xpp*xpp + ypp*ypp > 1.0;
+	    int infront = zpp > 0.0;
+	    mdp->svis = outside || infront;
+	}
+}
+
+/* set evis according to whether moon is geometrically visible from earth */
+static void
+moonEVis (MoonData md[J_NMOONS])
+{
+	int i;
+
+	for (i = 1; i < J_NMOONS; i++) {
+	    MoonData *mdp = &md[i];
+	    int outside = mdp->x*mdp->x + mdp->y*mdp->y > 1.0;
+	    int infront = mdp->z > 0.0;
+	    mdp->evis = outside || infront;
+	}
+}
+
+/* For RCS Only -- Do Not Edit */
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: jupmoon.c,v $ $Date: 2004-06-15 16:54:12 $ $Revision: 1.1 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/magdecl.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/magdecl.c	(revision 2551)
+++ /trunk/SophyaExt/XephemAstroLib/magdecl.c	(revision 2551)
@@ -0,0 +1,381 @@
+/* DoD NIMA World Magnetic Model.
+ * from http://www.ngdc.noaa.gov
+ *
+#define	TEST_MAIN
+ */
+
+
+#include <math.h>
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
+
+#include "astro.h"
+
+static char mfn[] = "wmm.cof";	/* file with model coefficients */
+
+static int geomag(FILE *wmmdat, int *maxdeg);
+static int geomg1(FILE *wmmdat, float alt, float glat, float glon,
+	float t, float *dec, float *mdp, float *ti, float *gv);
+
+/* compute magnetic declination for given location, elevation and time.
+ * sign is such that mag bearing = true az + mag deviation.
+ * return 0 if ok, -1 if no model file, -2 if time outside model range.
+ * fill err[] with excuse if return < 0.
+ */
+int
+magdecl (
+double l, double L,		/* geodesic lat, +N, long, +E, rads */
+double e,			/* elevation, m */
+double y,			/* time, decimal year */
+char *dir,			/* dir for model file */
+double *mdp,			/* magnetic deviation, rads E of N */
+char *err)			/* err message if return < 0 */
+{
+	float dlat = raddeg(l);
+	float dlon = raddeg(L);
+	float alt = e/1000.;
+	int maxdeg = 12;
+	float dec, dp, ti, gv;
+	char mfile[1024];
+	FILE *wmmdat;
+	int s;
+
+	/* open model file */
+	sprintf (mfile, "%s/%s", dir, mfn);
+	wmmdat = fopen (mfile, "r");
+	if (!wmmdat) {
+	    sprintf (err, "%s: %s", mfile, strerror(errno));
+	    return (-1);
+	}
+
+	/* compute deviation */
+	geomag(wmmdat, &maxdeg);
+	s = geomg1(wmmdat,alt,dlat,dlon,y,&dec,&dp,&ti,&gv);
+	fclose(wmmdat);
+	if (s < 0) {
+	    sprintf (err, "Magnetic model only available for %g .. %g. See http://www.ngdc.noaa.gov", ti, ti+5);
+	    return (-2);
+	}
+	*mdp = degrad(dec);
+	return (0);
+}
+
+#if defined(TEST_MAIN)
+
+int
+main(int ac, char *av[])
+{
+      char err[1024];
+      float altm, dlat, dlon;
+      float t;
+      double dec;
+
+    S1:
+      printf("\n\n\n ENTER LATITUDE IN DECIMAL DEGREES (+25.0)\n");
+      scanf("%f", &dlat);
+
+      printf(" ENTER LONGITUDE IN DECIMAL DEGREES (-100.0)\n");
+      scanf("%f", &dlon);
+
+      printf(" ENTER ALTITUDE IN METERS\n");
+      scanf("%f", &altm);
+
+      printf(" ENTER TIME IN DECIMAL YEAR\n");
+      scanf("%f",&t);
+
+      if (magdecl (degrad(dlat), degrad(dlon), altm, t, "auxil", &dec,
+								  err) < 0) {
+	  printf ("%s\n", err);
+	  return(1);
+      }
+
+      printf("\n LATITUDE:    = %-7.2f DEG",dlat);
+      printf("\n LONGITUDE:   = %-7.2f DEG\n",dlon);
+      printf("\n ALTITUDE     = %.2f  METERS",altm);
+      printf("\n DATE         = %-5.1f\n",t);
+
+      printf("\n\t\t\t      OUTPUT\n\t\t\t      ------");
+      
+      printf("\n DEC         = %-7.2f DEG", raddeg(dec));
+
+      printf("\n\n\n DO YOU NEED MORE POINT DATA? (y or n)\n");
+      scanf("%s", err);
+      if ((err[0] =='y')||(err[0] == 'Y')) goto S1;
+
+      return(0);
+}
+#endif	/* defined(TEST_MAIN) */
+
+/*************************************************************************
+ * return 0 if ok, -1 if time is out of range with base epoc in *ti
+ */
+
+static int E0000(FILE *wmmdat, int IENTRY, int *maxdeg, float alt,
+float glat, float glon, float t, float *dec, float *mdp, float *ti,
+float *gv)
+{
+     static int maxord,i,icomp,n,m,j,D1,D2,D3,D4;
+     static float c[13][13],cd[13][13],tc[13][13],dp[13][13],snorm[169],
+	  sp[13],cp[13],fn[13],fm[13],pp[13],k[13][13],pi,dtr,a,b,re,
+	  a2,b2,c2,a4,b4,c4,epoc,gnm,hnm,dgnm,dhnm,flnmj,otime,oalt,
+	  olat,olon,dt,rlon,rlat,srlon,srlat,crlon,crlat,srlat2,
+	  crlat2,q,q1,q2,ct,st,r2,r,d,ca,sa,aor,ar,br,bt,bp,bpp,
+	  par,temp1,temp2,parp,bx,by,bz,bh;
+     static char model[20], c_str[81], c_new[5];
+     static float *p = snorm;
+
+     switch(IENTRY){case 0: goto GEOMAG; case 1: goto GEOMG1;}
+
+GEOMAG:
+
+/* INITIALIZE CONSTANTS */
+      maxord = *maxdeg;
+      sp[0] = 0.0;
+      cp[0] = *p = pp[0] = 1.0;
+      dp[0][0] = 0.0;
+      a = 6378.137;
+      b = 6356.7523142;
+      re = 6371.2;
+      a2 = a*a;
+      b2 = b*b;
+      c2 = a2-b2;
+      a4 = a2*a2;
+      b4 = b2*b2;
+      c4 = a4 - b4;
+
+/* READ WORLD MAGNETIC MODEL SPHERICAL HARMONIC COEFFICIENTS */
+      c[0][0] = 0.0;
+      cd[0][0] = 0.0;
+      fgets(c_str, 80, wmmdat);
+      sscanf(c_str,"%f%s",&epoc,model);
+S3:
+      fgets(c_str, 80, wmmdat);
+/* CHECK FOR LAST LINE IN FILE */
+      for (i=0; i<4 && (c_str[i] != '\0'); i++)
+      {
+	c_new[i] = c_str[i];
+	c_new[i+1] = '\0';
+      }
+      icomp = strcmp("9999", c_new);
+      if (icomp == 0) goto S4;
+/* END OF FILE NOT ENCOUNTERED, GET VALUES */
+      sscanf(c_str,"%d%d%f%f%f%f",&n,&m,&gnm,&hnm,&dgnm,&dhnm);
+      if (m <= n)
+      {
+	c[m][n] = gnm;
+	cd[m][n] = dgnm;
+	if (m != 0) 
+	{
+	  c[n][m-1] = hnm;
+	  cd[n][m-1] = dhnm;
+	}
+      }
+      goto S3;
+
+/* CONVERT SCHMIDT NORMALIZED GAUSS COEFFICIENTS TO UNNORMALIZED */
+S4:
+      *snorm = 1.0;
+      for (n=1; n<=maxord; n++) 
+      {
+	*(snorm+n) = *(snorm+n-1)*(float)(2*n-1)/(float)n;
+	j = 2;
+	for (m=0,D1=1,D2=(n-m+D1)/D1; D2>0; D2--,m+=D1) 
+	{
+	  k[m][n] = (float)(((n-1)*(n-1))-(m*m))/(float)((2*n-1)*(2*n-3));
+	  if (m > 0) 
+	  {
+	    flnmj = (float)((n-m+1)*j)/(float)(n+m);
+	    *(snorm+n+m*13) = *(snorm+n+(m-1)*13)*sqrt(flnmj);
+	    j = 1;
+	    c[n][m-1] = *(snorm+n+m*13)*c[n][m-1];
+	    cd[n][m-1] = *(snorm+n+m*13)*cd[n][m-1];
+	  }
+	  c[m][n] = *(snorm+n+m*13)*c[m][n];
+	  cd[m][n] = *(snorm+n+m*13)*cd[m][n];
+	}
+	fn[n] = (float)(n+1);
+	fm[n] = (float)n;
+      }
+      k[1][1] = 0.0;
+
+      otime = oalt = olat = olon = -1000.0;
+      return (0);
+
+/*************************************************************************/
+
+GEOMG1:
+
+      dt = t - epoc;
+      if (otime < 0.0 && (dt < 0.0 || dt > 5.0)) {
+	  *ti = epoc;			/* pass back base time for diag msg */
+	  return (-1);
+      }
+
+      pi = 3.14159265359;
+      dtr = pi/180.0;
+      rlon = glon*dtr;
+      rlat = glat*dtr;
+      srlon = sin(rlon);
+      srlat = sin(rlat);
+      crlon = cos(rlon);
+      crlat = cos(rlat);
+      srlat2 = srlat*srlat;
+      crlat2 = crlat*crlat;
+      sp[1] = srlon;
+      cp[1] = crlon;
+
+/* CONVERT FROM GEODETIC COORDS. TO SPHERICAL COORDS. */
+      if (alt != oalt || glat != olat) 
+      {
+	q = sqrt(a2-c2*srlat2);
+	q1 = alt*q;
+	q2 = ((q1+a2)/(q1+b2))*((q1+a2)/(q1+b2));
+	ct = srlat/sqrt(q2*crlat2+srlat2);
+	st = sqrt(1.0-(ct*ct));
+	r2 = (alt*alt)+2.0*q1+(a4-c4*srlat2)/(q*q);
+	r = sqrt(r2);
+	d = sqrt(a2*crlat2+b2*srlat2);
+	ca = (alt+d)/r;
+	sa = c2*crlat*srlat/(r*d);
+      }
+      if (glon != olon) 
+      {
+	for (m=2; m<=maxord; m++) 
+	{
+	  sp[m] = sp[1]*cp[m-1]+cp[1]*sp[m-1];
+	  cp[m] = cp[1]*cp[m-1]-sp[1]*sp[m-1];
+	}
+      }
+      aor = re/r;
+      ar = aor*aor;
+      br = bt = bp = bpp = 0.0;
+      for (n=1; n<=maxord; n++) 
+      {
+	ar = ar*aor;
+	for (m=0,D3=1,D4=(n+m+D3)/D3; D4>0; D4--,m+=D3) 
+	{
+/*
+   COMPUTE UNNORMALIZED ASSOCIATED LEGENDRE POLYNOMIALS
+   AND DERIVATIVES VIA RECURSION RELATIONS
+*/
+	  if (alt != oalt || glat != olat) 
+	  {
+	    if (n == m) 
+	    {
+	      *(p+n+m*13) = st**(p+n-1+(m-1)*13);
+	      dp[m][n] = st*dp[m-1][n-1]+ct**(p+n-1+(m-1)*13);
+	      goto S50;
+	    }
+	    if (n == 1 && m == 0) 
+	    {
+	      *(p+n+m*13) = ct**(p+n-1+m*13);
+	      dp[m][n] = ct*dp[m][n-1]-st**(p+n-1+m*13);
+	      goto S50;
+	    }
+	    if (n > 1 && n != m) 
+	    {
+	      if (m > n-2) *(p+n-2+m*13) = 0.0;
+	      if (m > n-2) dp[m][n-2] = 0.0;
+	      *(p+n+m*13) = ct**(p+n-1+m*13)-k[m][n]**(p+n-2+m*13);
+	      dp[m][n] = ct*dp[m][n-1] - st**(p+n-1+m*13)-k[m][n]*dp[m][n-2];
+	     }
+	  }
+S50:
+/*
+    TIME ADJUST THE GAUSS COEFFICIENTS
+*/
+	  if (t != otime) 
+	  {
+	    tc[m][n] = c[m][n]+dt*cd[m][n];
+	    if (m != 0) tc[n][m-1] = c[n][m-1]+dt*cd[n][m-1];
+	  }
+/*
+    ACCUMULATE TERMS OF THE SPHERICAL HARMONIC EXPANSIONS
+*/
+	  par = ar**(p+n+m*13);
+	  if (m == 0) 
+	  {
+	    temp1 = tc[m][n]*cp[m];
+	    temp2 = tc[m][n]*sp[m];
+	  }
+	  else 
+	  {
+	    temp1 = tc[m][n]*cp[m]+tc[n][m-1]*sp[m];
+	    temp2 = tc[m][n]*sp[m]-tc[n][m-1]*cp[m];
+	  }
+	  bt = bt-ar*temp1*dp[m][n];
+	  bp += (fm[m]*temp2*par);
+	  br += (fn[n]*temp1*par);
+/*
+    SPECIAL CASE:  NORTH/SOUTH GEOGRAPHIC POLES
+*/
+	  if (st == 0.0 && m == 1) 
+	  {
+	    if (n == 1) pp[n] = pp[n-1];
+	    else pp[n] = ct*pp[n-1]-k[m][n]*pp[n-2];
+	    parp = ar*pp[n];
+	    bpp += (fm[m]*temp2*parp);
+	  }
+	}
+      }
+      if (st == 0.0) bp = bpp;
+      else bp /= st;
+/*
+    ROTATE MAGNETIC VECTOR COMPONENTS FROM SPHERICAL TO
+    GEODETIC COORDINATES
+*/
+      bx = -bt*ca-br*sa;
+      by = bp;
+      bz = bt*sa-br*ca;
+/*
+    COMPUTE DECLINATION (DEC), INCLINATION (DIP) AND
+    TOTAL INTENSITY (TI)
+*/
+      bh = sqrt((bx*bx)+(by*by));
+      *ti = sqrt((bh*bh)+(bz*bz));
+      *dec = atan2(by,bx)/dtr;
+      *mdp = atan2(bz,bh)/dtr;
+/*
+    COMPUTE MAGNETIC GRID VARIATION IF THE CURRENT
+    GEODETIC POSITION IS IN THE ARCTIC OR ANTARCTIC
+    (I.E. GLAT > +55 DEGREES OR GLAT < -55 DEGREES)
+
+    OTHERWISE, SET MAGNETIC GRID VARIATION TO -999.0
+*/
+      *gv = -999.0;
+      if (fabs(glat) >= 55.) 
+      {
+	if (glat > 0.0 && glon >= 0.0) *gv = *dec-glon;
+	if (glat > 0.0 && glon < 0.0) *gv = *dec+fabs(glon);
+	if (glat < 0.0 && glon >= 0.0) *gv = *dec+glon;
+	if (glat < 0.0 && glon < 0.0) *gv = *dec-fabs(glon);
+	if (*gv > +180.0) *gv -= 360.0;
+	if (*gv < -180.0) *gv += 360.0;
+      }
+      otime = t;
+      oalt = alt;
+      olat = glat;
+      olon = glon;
+      return (0);
+}
+
+/*************************************************************************/
+
+static int
+geomag(FILE *wmmdat, int *maxdeg)
+{
+     return (E0000(wmmdat,0,maxdeg,0.0,0.0,0.0,0.0,NULL,NULL,NULL,NULL));
+}
+
+/*************************************************************************/
+
+static int
+geomg1(FILE *wmmdat, float alt, float glat, float glon, float t,
+float *dec, float *mdp, float *ti, float *gv)
+{
+     return (E0000(wmmdat,1,NULL,alt,glat,glon,t,dec,mdp,ti,gv));
+}
+
+/* For RCS Only -- Do Not Edit */
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: magdecl.c,v $ $Date: 2004-06-15 16:54:12 $ $Revision: 1.1 $ $Name: not supported by cvs2svn $"};
